import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import javax.swing.*;
import java.awt.*;
import java.util.*;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.SourceDataLine;
import javax.sound.sampled.TargetDataLine;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;
import javax.swing.Timer;
import java.awt.Color;


public class Record extends JPanel implements ActionListener{
	AudioProjectPanel APPanel;
	boolean recording;
	String vowel;
	String spokenVowel;
	Capture capture;
	AudioInputStream audioInputStream;
	JButton captB;
	Timer t1;
	JLabel message;

	public Record(){
	}

	public Record(String vocal, double time, AudioProjectPanel APP){
		message = new JLabel();
		setLayout(new BorderLayout());
		APPanel = APP;
		vowel = vocal;
		recording = false;
		JPanel buttonsPanel = new JPanel();
		buttonsPanel.setLayout(new BorderLayout());
		buttonsPanel.setBorder(new EmptyBorder(10, 0, 5, 0));
		capture = new Capture(this, audioInputStream, time);
		captB = addButton(vocal, buttonsPanel, false);
		this.add(buttonsPanel, BorderLayout.PAGE_END);
		this.add(message, BorderLayout.CENTER);
	}
	
	private JButton addButton(String name, JPanel p, boolean state) {
		JButton b = new JButton(name);
		b.addActionListener(this);
		b.setEnabled(state);
		p.add(b, BorderLayout.PAGE_END);
		return b;
	}

	public void open() {
	}

	public void close() {
		if (capture.thread != null) {
			captB.doClick(0);
		}
	}

	public void actionPerformed(ActionEvent e){
		Object obj = e.getSource();
		if (obj.equals(captB)) {
    		capture.start();
    	}
	}

	public boolean IsRecording(){
		return recording;
	}
	
	public void checkAnswer() {
		System.out.println("Checkiando respuesta");
		spokenVowel = WhichVowel.getVowel();
		if(spokenVowel.equals(vowel)){ 
			captB.setBackground(Color.GREEN);
			APPanel.nivel.addScore();
			message.setText("Respuesta Correcta");
			this.updateUI();
		}
		else{
			captB.setBackground(Color.RED);
			message.setText("Respuesta Incorrecta");
			this.updateUI();
		}

		captB.setEnabled(false);	
		APPanel.nivel.addAnswer();
		
		if(APPanel.nivel.getAnswers() == APPanel.nivel.getLevel()){
			if(APPanel.nivel.getScore() == APPanel.nivel.getLevel()) {	
				APPanel.nivel.nextLevel();
				APPanel.nivel.LifeReset();												
				t1 = new Timer(4000, new ActionListener (){ //
					public void actionPerformed(ActionEvent event) {
						APPanel.begin();
   				}
				});
				t1.setRepeats(false);
				message.setText("Avanzas de Nivel");
				this.updateUI();
				t1.start();
			} else {
				APPanel.nivel.LifeDown();
				message.setText("Haz perdido una vida");
				this.updateUI();
				t1 = new Timer(4000, new ActionListener (){
					public void actionPerformed(ActionEvent event) {
						APPanel.begin();
   				}
				});
				t1.setRepeats(false);
				t1.start();
			}
		}
	}	 	
}
